begin def

' Including C:\BIN\MOON\ffblk.h
' bundle definition for FINDFIRST, FINDNEXT, FEXIST functions

bundle FFBLK attr@, time%, date%, size&, name$[13] null
' Including args.h
   sub getargs
   sub quoted( quoter$ )
   sub param
   sub other
   sub store( item$ )

   dim arg_v$[ 100 ]

   common cmd$, arg_c%
' Including addext.h
   sub addext( name$, ext$ )
   common withext$, withoutext$
' Including swapper.h
   common swapped$
   sub swapper( template$, symbol$, replacement$ )
' Including getini.h
   ' support items for use by ini.moo

   common inivalue$, iItemCount%, opstatus%, getini_file$

   DIM aIniBuffer$[ 1000 ]

   sub getIni( pInifile$, pIniSect$, pIniItem$, pIniDefault$ )
   sub insection( pItemno%, pMaxitems%, pItem$, pDefault$ )
   sub loadini( pInifile$ )

    dim search$[ 10 ]
    sub help:

    sub inclusions( filename$, outbuff% )

    common keepmarker%, comment$, marker$
    common outputfile$
    common nSearch%
begin code

   call getargs
   if arg_c% < 4 then
      call help
      end
   endif

   section$ = arg_v$[ 1 ]
   section$ = ucase( section$ )

   inputfile$= arg_v$[ 2 ]
   outputfile$= arg_v$[ 3 ]

   if fexist( inputfile$, 7 ) = false then
      print inputfile$ + " not found.\n\n"
      call help
      end
   endif

   inifile$ = arg_v$[ 0 ]
   call addext( inifile$, ".INI" )
   inifile$ = withext$

   if fexist( inifile$, 7 ) = false then
      print inifile$ + " not found.\n\n"
      call help
      end
   endif

   call getini( inifile$, section$, "Marker", space( 1 ) )
   if inivalue$ <> space( 1 ) then
      marker$ = inivalue$
   else
      marker$ = ".i"
   endif
   marker$ = lcase( marker$ )

   nSearch% = 0
   c% = 0
   forever% = true
   while forever%
      Searcher$ = "Search" + c%
      call getini( inifile$, section$, Searcher$, ":" )
      if inivalue$ = ":" then
         exit while
      else
         SearchRight$ = right( inivalue$, 1 )
         if SearchRight$ <> "\\" then
            inivalue$ = inivalue$ + "\\"
         endif
         Search$[ nSearch% ] = inivalue$
         nSearch% = nSearch% + 1
      endif
      c% = c% + 1
   wend
   if nSearch% = 0 then
      Search$[ nSearch% ] = ".\\"
   endif

   call getini( inifile$, section$, "KeepMarker", "0" )
   if inivalue$ = "1" then
      keepmarker% = true
   else
      keepmarker% = false
   endif

   call getini( inifile$, section$, "Comment", "'" )
   comment$ = inivalue$

   print "Producing " + outputfile$ + "\n"

   h_out% = fcreate( outputfile$, archive )
   push h_out%
   call inclusions( inputfile$, h_out% )
   pop h_out%
   fclose( h_out% )
   end

sub help:
    print "Usage:\n\tINCLUDE <type> <input file> <output file>\n"
   print "\nINCLUDE reads input file, checking for include markers and merges"
   print "\nspecified files into output file. Reads INCLUDE.INI in section"
   print "\nmatching first parameter of invocation. INCLUDE.INI defines"
   print "\ninclude marker, where to look for files, whether to keep"
   print "\nmarkers and what to prefix them with.\n"
end sub

' Including args.sub
sub getargs
   dquote$ = chr(34)
   squote$ = "'"

   me$ = mypath()
   me$ = ftruename( me$ )
   arg_v$[ 0 ] = me$

   arg_c% = 1

   'get command line
   cmd$ = cmdline

   'repeat until empty command line
   forever% = true
   while forever%
      cmd$ = ltrim( cmd$ )
      if cmd$ = "" then
         exit while
      endif

      'get first char of command line
      first$ = left( cmd$, 1 )

      select case first$
         case squote$
            call quoted( squote$ )
         case dquote$
            call quoted( dquote$ )
         case "/"
            call param
         case "-"
            call param
         case else
            call other
      end select
   wend
end sub
sub quoted( quoter$ )
   item$ = mid( cmd$, 2 )
   there% = sinstr( item$, quoter$ )
   if there% > 0 then
      there% = there% - 1
      item$ = left( item$, there% ) 'mid( item$, 1, there% )
      there% = there% + 3
      '... and remove this first item from the command line
      cmd$ = mid( cmd$, there% )
   else
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub param
   sep% = 32
   there% = cinstr( cmd$, sep% )
   if there% > 0 then
      there% = there% - 1
      item$ = left( cmd$, there% )
      '... and remove this first item from the command line
      there% = there% + 2
      cmd$ = mid( cmd$, there% )
   else
      item$ = cmd$
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub other
   'otherwise next item in array is first item
   there% = cinstr( cmd$, 32 )
   if there% > 0 then
      there% = there% - 1
      item$ = left( cmd$, there% )
      '... and remove this first item from the command line
      there% = there% + 2
      cmd$ = mid( cmd$, there% )
   else
      item$ = cmd$
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub store( item$ )
   arg_v$[ arg_c% ] = item$
   arg_c% = arg_c% + 1
end sub
' Including addext.sub
sub addext( name$, ext$ )
   truename$ = ftruename( name$ )
   extdot% = cinstr( truename$, 46 )
   if extdot% > 0 then
      extdot% = extdot% - 1
      withoutext$ = left( truename$, extdot% )
   else
      withoutext$ = truename$
   endif
   withext$ = withoutext$ + ext$
end sub
' Including swapper.sub
sub swapper( template$, symbol$, replacement$ )
    forever% = true
    swapped$ = template$
    if len( symbol$ ) < 1
       exit sub
    endif
    while forever%
        swapfind% = instr( swapped$, symbol$ )
        if swapfind% > 0 then
            leftswap% = swapfind% - 1
            swapleft$ = left( swapped$, leftswap% )
            rightswap% = swapfind% + len( symbol$ )
            swapright$ = mid( swapped$, rightswap% )
            swapped$ = swapleft$ + replacement$ + swapright$
        else
            exit while
        endif
    wend
end sub
' Including getini.sub
sub getIni( pInifile$, pIniSect$, pIniItem$, pIniDefault$ )
#ifdef GETINI
   fprint( 4, pInifile$ + " " + pIniSect$ + " " + pIniItem$ + " " + pIniDefault$ + "\n" )
#endif

   iniValue$ = pIniDefault$
   Section$ = "[" + pIniSect$ + "]"

   iniValue$ = pIniDefault$
#ifdef GETINI
   fprint( 4, getini_file$ + " " + pInifile$ + "\n" )
#endif
   if getini_file$ <> pInifile$ then
      call LoadIni( pInifile$ )
      getini_file$ = pInifile$
   endif
   IF iItemCount% > 0 then
      FOR Item% = 0 TO iItemCount%
         inputline$ = aIniBuffer$[ Item% ]
         inputline$ = ltrim( inputline$ )
         SectLen% = LEN( Section$ )
         Temp$ = LEFT( inputline$, SectLen% )
         IF Temp$ = Section$ then
            call InSection( Item%, iItemCount%, pIniItem$, pIniDefault$ )
            EXIT for
         ENDIF
      NEXT
   ENDIF
#ifdef GETINI
   fprint( 4, " " + iniValue$ + "\n" )
#endif
end sub

sub insection( pItemno%, pMaxitems%, pItem$, pDefault$ )
   Item$ = pItem$ + "="
   iniValue$ = pDefault$

   n% = pItemno% + 1
   FOR Item% = n% TO pMaxitems%
      inputline$ = aIniBuffer$[ Item% ]
      inputline$ = rTRIM( inputline$ )
      inputline$ = ltrim( inputline$ )
      LeftChar$ = LEFT( inputline$, 1 )
      IF LeftChar$ = "[" then
         EXIT for
      endif
      ItemLen% = Len( Item$ )
      Temp$ = LEFT( inputline$, ItemLen% )
      IF Temp$ = Item$ then
         ItemLen% = ItemLen% + 1
         iniValue$ = mid( inputline$, ItemLen% )
         EXIT for
      ENDIF
   NEXT
end sub

sub loadini( pInifile$ )
    iItemCount% = 0
    if fexist( pIniFile$, 7 ) = false then
        exit sub
    endif
    iniHandle% = fopen( pInifile$, readonly )
    forever% = true
    while forever%
        inputline$ = space(127)
        finput(iniHandle%, inputline$)
        if feof( iniHandle% ) = true then
            exit while
        endif
        inputline$ = rTRIM( inputline$ )
        aIniBuffer$[ iItemCount% ] = inputline$
        iItemCount% = iItemCount% + 1
    wend
    fclose( iniHandle% )
end sub


sub inclusions( filename$, outbuff% )
   print "Reading " + filename$ +".\n"
   inbuff% = fopen( filename$, readonly )
   forever% = true
   while forever%
      finput( inbuff%, inrec$ )
      if feof( inbuff% ) = true then
         exit while
      endif
      temp$ = ltrim( inrec$ )
      temp$ = lcase( temp$ )
      if temp$ = "" then
         fprint( outbuff%, inrec$ + "\n" )
      else
         pos% = instr( temp$, marker$ )
         if pos% <> 1 then
            fprint( outbuff%, inrec$ + "\n" )
         else
            here% = len( marker$ )  + 1
            incfile$ = mid( temp$, here% )
            incfile$ = ltrim( incfile$ )
            found% = false
            for nn% = 0 to nSearch%
               finder$ = search$[ nn% ] + incfile$
#ifdef DEBUG
               print "finder$=" + finder$ + "\n"
#endif
               if fexist( finder$, 7 ) = true then
                  found% = true
                  exit for
               endif
            next nn%
            if found% = true then
               if keepmarker% = true then
                  fprint( outbuff%, comment$ + " Including " + finder$ + "\n" )
               endif
               push inbuff%
               push outbuff%
               call inclusions( finder$, outbuff% )
               pop outbuff%
               pop inbuff%
            else
               print "Could not find " + incfile$ + "\n"
               exit while
            endif
         endif
      endif
   wend
   fclose( inbuff% )
end sub

